/********************************************************************
	created:	2002/09/23
	created:	23:9:2002   15:00
	filename: 	Command.h
	file path:	Nr6Test
	file base:	Command
	file ext:	h
	author:		swordhui
	
	purpose:	Parse DicNet Client Command.
*********************************************************************/

#pragma once
#include "windows.h"


//Cmd structure.
typedef struct
{
	char*	chCmd;
	DWORD	dwFuncAddr;
	char*	chHelp;
}EDEN_CMD;		


typedef void (*CMDFUNC)(char *cmdline);


//Main loop; input cmd and parse it.
void parse_command();

//Show help message.
void OnHelp(char *cmdline);

//Check if NrCli5.dll loaded.
//return 1 means loaded. other failed.
int CheckDll();

//Show version info.
void DoVer();

//Find Command.
void DoFind(char *cmdLine);	

//Query Infomation.
void DoQuery(char *cmdLine);


//Open Selected Device.
void DoOpen(char *cmdLind);


//Close Current selected handle.
void DoClose();


//Get card information.
void DoGetCard();

//List all handles.
void DoListHandle();

//Set current handle.
void DoSettHandle(char* cmdLine);

//Get Hardware info
void DoGetHWInfo();

//Get Manager code.
void DoGetMCode();

//Get Privilege
void Prvg();

//Get Romote Info.
void GetRomoteInfo();

//Set Romote Info.
void SetRomoteInfo(LPCTSTR cmdLine);

//Check Remote Info.
void ChkRomoteInfo(LPCTSTR cmdLine);



//List All Device
void DoList();

//Dir
void Dir();

//cd
void DoCD(LPCTSTR cmdLine);

//md
void DoMD(LPCTSTR cmdLine);

//rd
void DoRD(LPCTSTR cmdLine);

//Select
void Select(LPCTSTR cmdLine);

//Create file.
void Create(LPCTSTR cmdLine);

//Delete current selected file.
void Delete();

//Run application.
void Run(LPCTSTR cmdLine);

//Read file.
void DoRead(LPCTSTR cmdLine);

//Write File.
void DoWrite(LPCTSTR cmdLine);


void DoLock();

void DoUnlock();







