/********************************************************************
	created:	2002/09/23
	created:	23:9:2002   14:31
	filename: 	ROCKEY.h
	file path:
	file base:	ROCKEY
	file ext:	h
	author:		swordhui

	purpose:	interface for the ROCKEY.
*********************************************************************/

#ifndef  __ROCKEY__
#define __ROCKEY__
#pragma once

#include "windows.h"
#include "DIC32.h"

//Function protype defination

#define R5_FUNCNAME_FIND "DIC_Find"
typedef int (WINAPI *DICFIND)();

#define R5_FUNCNAME_OPEN "DIC_Open"
typedef int (WINAPI* DICOPEN)(int hic, char* reader_name);

#define R5_FUNCNAME_CLOSE "DIC_Close"
typedef int (WINAPI* DICCLOSE)(DWORD dwHandle);

#define R5_FUNCNAME_CMD "DIC_Command"
typedef int (WINAPI* DICCOMMAND)(int hic, int cmd, void* cmddata);

#define R5_FUNCNAME_VER "DIC_GetVersion"
typedef int (WINAPI* DICGETVER)(char* ver);

typedef int (WINAPI* DICGet)(void* xdata, int p1, int p2, char* buffer);

typedef int (WINAPI* DICSet)(void* xdata, int p1, int p2, int p3, char* buffer);

typedef int (WINAPI* DICFINDMGR)(PVOID pMgrCode);




class CROCKEY
{
public:

	int m_bInitOK;

    int Find();
    int Open(int hic, char* reader_name);
	int Command(int hic, int cmd, void* cmddata);
	int Close(DWORD dwHandle);
        int GetVer(char* pVer);
	int Get(void* xdata, int p1, int p2, char* buffer);
	int Set(void* xdata, int p1, int p2, int p3, char* buffer);
    int FindMgr(PVOID pMgrCode);

    CROCKEY();
	virtual ~CROCKEY();



private:
	HMODULE		m_hDll;

	DICFIND		m_pDicFind;
	DICOPEN		m_pDicOpen;
	DICCLOSE	m_pDicClose;
	DICCOMMAND	m_pDicCmd;
    DICGETVER   m_pGetVer;
	
	DICGet    m_pGet;
	DICSet    m_pSet;
    DICFINDMGR m_pFindMgr;
    int Init();
};
#endif


