! ==========================================================
!// find, open and close all the ROCKEY
! ==========================================================

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code
integer*4 num 				! number of ROCKEY
integer*4 hic 				! device handle
integer*4 i 
CHARACTER*256 reader_name

	write(*,*) 'Searching ROCKEY ' 
	num = DIC_Find() 
	write(*,*) num 
	if (num <= 0) then	
		write(*,*)'No ROCKEY found' 
		stop
	endif 

	do i=0, num-1
		write(*,*) 'Open ROCKEY' 
		hic = DIC_Open(i, loc(reader_name))
		if (hic < 0) then		
			if (hic == SCARD_W_REMOVED_CARD) then
				write(*,*)'No ROCKEY found' 
				continue 
			endif 
			write(*,'(" Error code:",z8)') hic
			stop 
		endif
		write(*,'(A16)') reader_name 

		! ...
		! operate ROCKEY
		! ...

	write(*,*)'Close ROCKEY'
	errcode = DIC_Close(hic) 
	if (errcode /= SCARD_S_SUCCESS) then
        write(*,'(" error Code:",z8)') errcode
		stop
	endif 
enddo
end

	