! ==========================================================================
! counter
! (1) set counter
! (2) start counter
! description
!  (1) if set the counter to 0, it means no limitation
!  (2) if the counter decreases to 0, the it stops and becomes invalid
! ==========================================================================
!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code 
integer*4 num 				! number of founded card reader(s)
integer*4 hic 				! handle of Rockey device.
integer*4 i ,j
integer*4 ret_code,dwMaxCounter 
CHARACTER*256 reader_name
CHARACTER cmddata(512) 	
CHARACTER buffer(256) 	
CHARACTER*256 buffer2
CHARACTER*20  p_null
CHARACTER c_temp(20) 	



	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		! Stop searching once one is found.
	enddo

	if (i == num)  then
        	stop
	endif

	! a. Change to super user status (Only super users are allowed to create executable files)
	do i=1 ,8
	cmddata(i)=char(255)  ! Super password is 8 FFs for demo ROCKEY
	enddo		
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, loc(cmddata)) 
	
	!set the counter
	dwMaxCounter=5
	errcode = DIC_Command(hic, SETCOUNTER, loc(dwMaxCounter))
	
	if (errcode <> SCARD_S_SUCCESS) then
		write(*,*)'Set Counter err'		
	endif



	! b. cancel the supper password status
	errcode = DIC_Close(hic) 
	errcode = DIC_Open(hic, loc(p_null)) 

	! STEPCOUNTER
	do i=0,dwMaxCounter
		errcode = DIC_Command(hic, STEPCOUNTER, NULL)
		if(errcode <> SCARD_S_SUCCESS) then
			if(i>=dwMaxCounter) then
		
				write(*,*) 'i> dwMaxCounter'
				write(*,*) 'Step Counter ok'
				do j=1 ,8
					cmddata(j)=char(255)  ! Super password is 8 FFs for demo ROCKEY
				enddo		
				errcode = DIC_Command(hic, CHECK_SUPER_PASS, loc(cmddata))
				
				! if set the counter to 0, it means no limitation
				dwMaxCounter = 0
				errcode = DIC_Command(hic, SETCOUNTER, loc(dwMaxCounter))
				if(errcode <> SCARD_S_SUCCESS)then
				
					write(*,*)'Set Counter err'	
				endif			
			else
				write(*,*)'Step Counter err'			
			endif
			
		endif
	enddo
		
	! m. close
	errcode = DIC_Close(hic) 
end

	