* =========================================================================================================================
* goal: DES, 3 DES encryption and decryption 
* note: 
* in ROCKEY6 SE, if retained the DES and RSA algorithm module, can use DES, 3 DES and RSA and solution
* close function. Use process is as follows: 
* (1) establish internal data files (need super password)
* (2) write DES or 3 DES key (need super password) 
* (3) according to file ID and key ID for data encryption. Encryption, the length of the data must be in multiples of 8, less than 8 
* of integer is need the data fill, decryption, according to former filling rule will fill data can be removed.
* note:
* (1) DES and 3 DES keys according to the length of the key to distinction, length is 8 bytes of key for DES keys, length is 16 
* bytes of key for 3 des key. 
* (2) write DES key and 3 DES key is, use of the data structure is 
* DES key 10 bytes: key ID (1 byte) + key length (1 byte, value should be 8) + key (8 bytes)
* 3 des key a total of 18 byte: key ID (1 byte) + key length (1 byte, value should be 16) + key (16 bytes)
* =========================================================================================================================



#include "Dic32_Vfp.h"
clear 
DECLARE integer   DIC_Find IN Dic32u.dll
DECLARE integer   DIC_Open IN Dic32u.dll integer hic, string @  reader_name
DECLARE integer   DIC_Close  IN Dic32u.dll  integer   hic
DECLARE integer   DIC_Command  IN Dic32u.dll  integer  hic, integer cmd, string @  cmddata
DECLARE integer   DIC_Get  IN Dic32u.dll  string @xdata, integer  p1, integer   p2, string @buffer
DECLARE integer   DIC_Set  IN Dic32u.dll  string @xdata, integer  p1, integer  p2, integer   p3, string @buffer


store 0 to  errcode		   && Error code
store 0 to  num		   && To find the number of the card reader
store 0 to  hic		   && Equipment handle
store 0 to  i,j
store 0 to temp

store 8 to dataLen
dimension temp[8]


cmddata = space(1024)
buffer = space(1024)

	num = DIC_Find()
	for i=0 to num-1
		hic = DIC_Open(i, NULL)
		if (hic >= 0) 
		  exit  	&& No longer find when find one
  	  endif
	endfor
	if (i == num) 
	     return
    endif

	* establish des and tdes key file, respectively write a des and tdes key 
	* create documents 0x6F01
	DIC_Set(@cmddata, FILL, 256, 0, NULL)	&& clear
	DIC_Set(@cmddata, FILE_ID, BY_VALUE, 0x6F01, NULL)	&& file ID
	DIC_Set(@cmddata, FILE_CLASS, BY_VALUE, 0xff, NULL)	&& file type
	DIC_Set(@cmddata, FILE_ATTRIBUTE, BY_VALUE, FILEATTR_NORMAL, NULL)	&& File attributes, internal documents
	DIC_Set(@cmddata, FILE_SIZE, BY_VALUE, 28, NULL)	&& file size
	DIC_Set(@cmddata, FILE_NAME, BY_ARRAY, 0, "des")	&& long file name
	errcode = DIC_Command(hic, CREATE_FILE, @cmddata)



    && To file write 8 bytes des keys, please pay attention to the structure of the key
    DIC_Set(@buffer,0,1,1,NULL)
    DIC_Set(@buffer,1,1,8,NULL)
    for i=0 to 7
    	DIC_Set(@buffer,2+i,1,i,NULL)
    endfor
    
	DIC_Set(@cmddata, WRITE_DATA, 10, 0, @buffer)
	errcode = DIC_Command(hic, WRITE_FILE, @cmddata)
	
    DIC_Set(@buffer,0,1,2,NULL)
    DIC_Set(@buffer,1,1,16,NULL)
    for i=0 to 15
    	DIC_Set(@buffer,2+i,1,i,NULL)
    endfor   
    && To file write 16 bytes 3 des keys
	&& Note that the second time to write a key, must input file offset, the example of the offset is 10
	
	DIC_Set(@cmddata, WRITE_DATA, 18, 10, @buffer)
	errcode= DIC_Command(hic, WRITE_FILE, @cmddata)
	

&&================================des encrypt =8=========================================&&
	?"des: "
	for i=0 to 7
    	DIC_Set(@buffer,i,1,i,NULL)
    endfor   
	
	DIC_Set(@cmddata,DES_KEYFILEID,0,0x6F01,NULL)
	DIC_Set(@cmddata,DES_KEYINDEX,0,0x01,NULL)
	DIC_Set(@cmddata,DES_DATA,BY_ARRAY + dataLen,0,@buffer)
	errcode = DIC_Command(hic, DESENC, @cmddata)
	wRet = DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @buffer)
	?"Cipher text: "
	for i=0 to 7
	   temp[i+1]=DIC_Get(@buffer,i,1,NULL)
    endfor
    ?temp[1],temp[2],temp[3],temp[4],temp[5],temp[6],temp[7],temp[8]
		
 &&====================================des decrypt =8===================================&&  
   		
	DIC_Set(@cmddata,DES_KEYFILEID,0,0x6F01,NULL)
	DIC_Set(@cmddata,DES_KEYINDEX,0,0x01,NULL)
	DIC_Set(@cmddata,DES_DATA,BY_ARRAY + dataLen,0,@buffer)
	errcode = DIC_Command(hic, DESDEC, @cmddata)
	wRet = DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @buffer)
	?"Plant text: "
	for i=0 to 7
	   temp[i+1]=DIC_Get(@buffer,i,1,NULL)
    endfor
    ?temp[1],temp[2],temp[3],temp[4],temp[5],temp[6],temp[7],temp[8]

	&&================================3des encrypt =8=========================================&&
	?"3des: "
	for i=0 to 7
    	DIC_Set(@buffer,i,1,i,NULL)
    endfor   
	
	DIC_Set(@cmddata,DES_KEYFILEID,0,0x6F01,NULL)
	DIC_Set(@cmddata,DES_KEYINDEX,0,0x02,NULL)
	DIC_Set(@cmddata,DES_DATA,BY_ARRAY + dataLen,0,@buffer)
	errcode = DIC_Command(hic, DESENC, @cmddata)
	wRet = DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @buffer)
	?"Cipher text: "
	for i=0 to 7
	   temp[i+1]=DIC_Get(@buffer,i,1,NULL)
    endfor
    ?temp[1],temp[2],temp[3],temp[4],temp[5],temp[6],temp[7],temp[8]
		
 &&====================================3des decrypt =8===================================&&  
   		
	DIC_Set(@cmddata,DES_KEYFILEID,0,0x6F01,NULL)
	DIC_Set(@cmddata,DES_KEYINDEX,0,0x02,NULL)
	DIC_Set(@cmddata,DES_DATA,BY_ARRAY + dataLen,0,@buffer)
	errcode = DIC_Command(hic, DESDEC, @cmddata)
	wRet = DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @buffer)
	?"Plant text: "
	for i=0 to 7
	   temp[i+1]=DIC_Get(@buffer,i,1,NULL)
    endfor
    ?temp[1],temp[2],temp[3],temp[4],temp[5],temp[6],temp[7],temp[8]
	
	errcode = DIC_Close(hic) 
	
clear dlls
return 	