// ==========================================================================
// Get free space in byte
// ==========================================================================

import java.io.*;

public class Sample17
{
	public Sample17()
	{
	}
	public static void main(String [] args)
	{
		int i,num, hic=0, errcode;
		
		JavaRockey Rockey=new JavaRockey();
		System.out.print("Searching ROCKEEY ");
		num = Rockey.DIC_Find();
		if (num <= 0)
		{
			System.out.print("No ROCKEY found\n");
			return;
		}
		System.out.println(num);
	
		System.out.print("Open ROCKEY\n");
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, null);	
			if (hic >= 0) break;		// find the first ROCKEY
		}
		if (i == num)
		{
			System.out.print("No ROCKEY found\n");
			return;
		}
		
		//get free space
		int dwFreeSpace = 0;
		byte []tmp=new byte[4];
		errcode = Rockey.DIC_Command(hic, Rockey.GETFREESPACE, tmp);

		dwFreeSpace+=(tmp[3] & 0x000000FF)<<24;
		dwFreeSpace+=(tmp[2] & 0x000000FF)<<16;
		dwFreeSpace+=(tmp[1] & 0x000000FF)<<8;
		dwFreeSpace+=(tmp[0] & 0x000000FF);
		System.out.print("The free space is "+dwFreeSpace+" bytes,"+dwFreeSpace/1024+" K.\n");
	
		Rockey.DIC_Close(hic);
	}
}