//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdio.h"
#include "Rockey.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Memo1->Clear();
}
//---------------------------------------------------------------------------


//------------------------------------------------------------------------------
// readdata.c ,read file .
//
// input: 2 byte, File ID to read.
// output: data of file.
//
//
//compile to make readdata.bin.
//------------------------------------------------------------------------------

// ==========================================================================
//void main(void)
//{
// word fileID;
// word fileSize;
// byte b_fileSize;
// byte xdata out[30];
// byte xdata result[100],ret;

// get_input(&fileID,0,1,1);
// open_file(&fileID, 0);
// get_file_infor(out, 1);
// fileSize = (out[5]<<8)|out[4];
// read_file(0,result,fileSize);
// b_fileSize=(unsigned char)fileSize;

//set_response(b_fileSize, result);
// exit();
//}
// ==========================================================================




//------------------------------------------------------------------------------
// conver from  readdata.bin , executable code.
//------------------------------------------------------------------------------

#define READDATA_SIZE  276
unsigned char g_progReadData[READDATA_SIZE]=
{
0x02,0x01,0x04,0x75,0x0c,0x00,0x75,0x0d,0x00,0x75,0x0e,0x08,0xe4,0xf5,0x0f,0x75,
0x10,0x01,0x75,0x11,0x01,0x12,0x00,0xa0,0x75,0x0c,0x00,0x75,0x0d,0x00,0x75,0x0e,
0x08,0xe4,0xf5,0x0f,0x12,0x00,0xbf,0x75,0x0c,0x01,0x75,0x0d,0x00,0x75,0x0e,0x00,
0x75,0x0f,0x01,0x12,0x00,0xed,0x90,0x00,0x04,0xe0,0xfe,0xa3,0xe0,0xfd,0xee,0xf5,
0x0a,0xed,0xf5,0x0b,0xe4,0xf5,0x0c,0xf5,0x0d,0x75,0x0e,0x01,0x75,0x0f,0x00,0x75,
0x10,0x0c,0x85,0x0a,0x11,0x85,0x0b,0x12,0x12,0x00,0x7d,0xd3,0xe5,0x0b,0x94,0xff,
0xe5,0x0a,0x94,0x00,0x40,0x04,0x7f,0xff,0x80,0x02,0xaf,0x0b,0x8f,0x0c,0x75,0x0d,
0x01,0x75,0x0e,0x00,0x75,0x0f,0x0c,0x12,0x00,0xd6,0x02,0x01,0x10,0x12,0xff,0x00,
0xe5,0x0c,0x24,0x00,0xe5,0x0d,0x24,0x01,0xe5,0x0e,0x24,0x02,0xe5,0x0f,0x24,0x03,
0xe5,0x10,0x24,0x04,0xe5,0x11,0x24,0x05,0xe5,0x12,0x24,0x06,0x12,0xff,0x03,0x22,
0x12,0xff,0x00,0xe5,0x0c,0x24,0x00,0xe5,0x0d,0x24,0x01,0xe5,0x0e,0x24,0x02,0xe5,
0x0f,0x24,0x03,0xe5,0x10,0x24,0x04,0xe5,0x11,0x24,0x05,0x12,0xff,0x0b,0x22,0x12,
0xff,0x00,0xe5,0x0c,0x24,0x00,0xe5,0x0d,0x24,0x01,0xe5,0x0e,0x24,0x02,0xe5,0x0f,
0x24,0x03,0x12,0xff,0x02,0x22,0x12,0xff,0x00,0xe5,0x0d,0x24,0x00,0xe5,0x0e,0x24,
0x01,0xe5,0x0f,0x24,0x02,0xe5,0x0c,0x24,0x03,0x12,0xff,0x0a,0x22,0x12,0xff,0x00,
0xe5,0x0c,0x24,0x00,0xe5,0x0d,0x24,0x01,0xe5,0x0e,0x24,0x02,0xe5,0x0f,0x24,0x03,
0x12,0xff,0x06,0x22,0x78,0x7f,0xe4,0xf6,0xd8,0xfd,0x75,0x81,0x12,0x02,0x00,0x03,
0x12,0xff,0x0d,0x22,
};


void __fastcall TForm1::Button1Click(TObject *Sender)
{

        CROCKEY        Ry;
        char            chMsg[256];
        int             iRet,i,iDevID;

        //----------------------------------------------------------------------
        //Demo0: Init Rockey Class.
        //----------------------------------------------------------------------

        Memo1->Clear();
        if(!Ry.m_bInitOK)
        {
            //Init failed. dll not found.
            Memo1->Lines->Add("Error: Dic32u.dll not found.Please ensure it's in current directory.");
            goto ENDFUNC;
        }
        else
        {
            //Succeeded. Show current dll version.
            char chDllVer[32];

            Ry.GetVer(chDllVer);
            sprintf(chMsg,"Dll bounded. ver %s.",chDllVer);
            Memo1->Lines->Add(chMsg);
        }

        //----------------------------------------------------------------------
        //Demo1:Find.
        //Get maximum device numbers.
        //----------------------------------------------------------------------

        int iMaxDevs;

        iMaxDevs=Ry.Find();
        if(!CheckResult(iMaxDevs,"DIC_Find")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Find: found %d devices.\r\n",iMaxDevs);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo2:Open
    	//Open the first device.
        //----------------------------------------------------------------------



	    sprintf(chMsg,"******** Opening device ...");
        Memo1->Lines->Add(chMsg);

        for(i=0; i<iMaxDevs; i++)
        {
            iRet=Ry.Open(i,NULL);      //No need to know the name of Card.
            if(iRet>=0) break;          //break if succeess, only open the first.
        }

        if(i==iMaxDevs)
        {
            Memo1->Lines->Add("Error: Please insert a Rockey to retry.");
            goto ENDFUNC;
        }
        else
        {
            sprintf(chMsg,"Device %d opened.\r\n",i);
            Memo1->Lines->Add(chMsg);
        }

        iDevID=i;

        //----------------------------------------------------------------------
        //Demo3:Check super password.
        //----------------------------------------------------------------------

        BYTE bySuperPassword[8];

        for(i=0; i<8; i++) bySuperPassword[i]=0xFF;

        Memo1->Lines->Add("******** Check super password FF FF FF FF FF FF FF FF");
	    iRet=Ry.Command(iDevID,CHECK_SUPER_PASS,bySuperPassword);

	    if(iRet<0)
	    {
		    Memo1->Lines->Add("Error: super password is not FF FF FF FF FF FF FF FF,please modify it.\r\n");
		    goto ENDFUNC;
	    }

	    Memo1->Lines->Add("[OK]\r\n");


        //Format card to erase exe-files.
        //You can sikp this step if you only run this demo once.

        DICST_System_Info FormatInfo;

        strncpy(FormatInfo.atr,"ATR_Test",15);
        strncpy(FormatInfo.volume,"Volumn_Test",16);

	    iRet=Ry.Command(iDevID,FORMAT_CARD,&FormatInfo);
	    if(!CheckResult(iRet,"DIC_CMD:FORMAT_CARD")) goto ENDFUNC;



        //----------------------------------------------------------------------
        //Demo4:Crypto executable file.
        //----------------------------------------------------------------------

        //We mush have enough space to store encrypted data!
        //size is  (Len/64+1)*68+64
        BYTE byExeCryptBuf[(READDATA_SIZE/64+1)*68+64];

        DICST_Before_CryptoFile_Data*   pBCrypt;
        DICST_After_CryptoFile_Data*    pACrypt;

        pBCrypt=(DICST_Before_CryptoFile_Data*)byExeCryptBuf;
        pACrypt=(DICST_After_CryptoFile_Data*) byExeCryptBuf;

        sprintf(chMsg,"******** Crypto exe file. length:%d.",READDATA_SIZE);
        Memo1->Lines->Add(chMsg);

        pBCrypt->fileid=0x0023;
        pBCrypt->filecla=0xFF;
        pBCrypt->fileatrpri=FILEATTR_EXEC;
        pBCrypt->filesize=READDATA_SIZE;
        strncpy(pBCrypt->filename,"6088",16);
        memcpy(pBCrypt->filedata,g_progReadData,READDATA_SIZE);

        iRet=Ry.Command(iDevID,CRYPTOTEXT_FILE,byExeCryptBuf);
	    if(!CheckResult(iRet,"DIC_CMD:CRYPTOTEXT_FILE")) goto ENDFUNC;

        sprintf(chMsg,"[OK],return length is %d\r\n",pACrypt->ResultSize);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo5:Encrypto data file
        //----------------------------------------------------------------------

        //set data. len is 80, '0'-'9', 8 times.
        BYTE byData[80];
        for (i=0;i<80;i++) byData[i] = 0x30+(i%10);

        //We mush have enough space to store encrypted data!
        //size is  (Len/64+1)*68+64
        BYTE byDataCryptBuf[(80/64+1)*68+64];

        pBCrypt=(DICST_Before_CryptoFile_Data*)byDataCryptBuf;
        pACrypt=(DICST_After_CryptoFile_Data*) byDataCryptBuf;

        sprintf(chMsg,"******** Crypto data file. length:%d.",80);
        Memo1->Lines->Add(chMsg);

        pBCrypt->fileid=0x0057;
        pBCrypt->filecla=0xFF;
        pBCrypt->fileatrpri=0;
        pBCrypt->filesize=80;
        strncpy(pBCrypt->filename,"File1",16);
        memcpy(pBCrypt->filedata,byData,80);

        iRet=Ry.Command(iDevID,CRYPTOTEXT_FILE,byDataCryptBuf);
	    if(!CheckResult(iRet,"DIC_CMD:CRYPTOTEXT_FILE")) goto ENDFUNC;

        sprintf(chMsg,"[OK],return length is %d\r\n",pACrypt->ResultSize);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo6: Select and remove file.
        //----------------------------------------------------------------------
        DICST_File fileSet;

        memset(&fileSet,0,sizeof(fileSet));

        //Select and remove exe file. 0x0023

	    Memo1->Lines->Add("******** Remove file 0x0023");
        fileSet.fileid=0x0023;
        iRet=Ry.Command(iDevID,SET_CURRENT_FILE,&fileSet);
	    if(!CheckResult(iRet,"DIC_CMD:SET_CURRENT_FILE")) goto ENDFUNC;

        iRet=Ry.Command(iDevID,REMOVE_FILE,NULL);
	    if(!CheckResult(iRet,"DIC_CMD:REMOVE_FILE")) goto ENDFUNC;

   	    Memo1->Lines->Add("[OK]\r\n");

        //Select and remove data file. 0x0057
        Memo1->Lines->Add("******** Remove file 0x0057");
        fileSet.fileid=0x0057;
        iRet=Ry.Command(iDevID,SET_CURRENT_FILE,&fileSet);
	    if(!CheckResult(iRet,"DIC_CMD:SET_CURRENT_FILE")) goto ENDFUNC;

        iRet=Ry.Command(iDevID,REMOVE_FILE,NULL);
	    if(!CheckResult(iRet,"DIC_CMD:REMOVE_FILE")) goto ENDFUNC;

   	    Memo1->Lines->Add("[OK]\r\n");



        //----------------------------------------------------------------------
        //Demo7, Close and reopen to return normal privilege.
        //
        //----------------------------------------------------------------------

	    Memo1->Lines->Add("******** Return to normal privilege");

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

	    iRet=Ry.Open(iDevID,NULL);
	    if(!CheckResult(iRet,"DIC_Open")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo8, PlainTextFile.
        //that will create a new exe file and a new data file in card.
        //----------------------------------------------------------------------

        //plain executable file.

	    Memo1->Lines->Add("******** Plain crypted exe file to card.");

        pACrypt=(DICST_After_CryptoFile_Data*) byExeCryptBuf;
        iRet=Ry.Command(iDevID,PLAINTEXT_FILE,pACrypt->Result);
	    if(!CheckResult(iRet,"DIC_CMD:PLAINTEXT_FILE")) goto ENDFUNC;
        Memo1->Lines->Add("[OK]\r\n");


        //plain data file.

        Memo1->Lines->Add("******** Plain crypted data file to card.");

        pACrypt=(DICST_After_CryptoFile_Data*) byDataCryptBuf;
        iRet=Ry.Command(iDevID,PLAINTEXT_FILE,pACrypt->Result);
	    if(!CheckResult(iRet,"DIC_CMD:PLAINTEXT_FILE")) goto ENDFUNC;
        Memo1->Lines->Add("[OK]\r\n");

                  
        //----------------------------------------------------------------------
        //Demo6,Run program, Run Name is "6088",not program ID.
	    //read data file (0x0057).
        //----------------------------------------------------------------------

        BYTE    byRunBuf[80+4];  //This must > max_size(input,return)+4, (> 4+4=8)
        char    chTemp[32];
        WORD    usFileID;

        DICST_Before_Run_Data*  pBRun;
        DICST_After_Run_Data*   pARun;

        pBRun=(DICST_Before_Run_Data*)byRunBuf;
        pARun=(DICST_After_Run_Data*) byRunBuf;

        Memo1->Lines->Add("******** Run to read file 0x0057");

        usFileID=0x0057;

        pBRun->RunID=0x6088;
        pBRun->ParaSize=2;
        memcpy(&pBRun->Para[0],&usFileID,2); //the first parameter,File ID


        iRet=Ry.Command(iDevID,RUN,byRunBuf);
	    if(!CheckResult(iRet,"DIC_CMD:RUN")) goto ENDFUNC;

        //Show Return data.
        for(int i=0; i<8; i++)
        {
            strncpy(chMsg,&pARun->Result[i*10],10);
            chMsg[10]=0;

            Memo1->Lines->Add(chMsg);
        }


	    sprintf(chMsg,"[OK],return size is %d\r\n",pARun->ResultSize);
        Memo1->Lines->Add(chMsg);


        //----------------------------------------------------------------------
        // Demo7 : Close
        //----------------------------------------------------------------------

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Closed.\r\n");
        Memo1->Lines->Add(chMsg);



ENDFUNC:


        Memo1->Lines->Add("\r\n[Test finished]");
}
//---------------------------------------------------------------------------



//Return 1 if succeeded.
//return 0 means failed.
int TForm1::CheckResult(int iRetCode, char* pFuncName)
{
    //TODO: Add your source code here
    int iRet=1;

    if(iRetCode<0)                  
    {
        char chMsg[512];
        memset(chMsg,0,512);
        sprintf(chMsg,"Error: %s failed, code %08x",pFuncName,iRetCode);
        Memo1->Lines->Add(chMsg);
        iRet=0;
    }

    return iRet;
}
