// ==========================================================================
// Get managment code
// (1) managment code help developers to manage ROCKEY. Users cannot change it.
//	a) Zone Code, ROCKEY is sold in which area
//	b) Agent Code, sold via which agent
//	c) User1 code, sold to which user
//	d) User1 code, sold to which user
// (2) Use DIC_Get to get the info
// ==========================================================================
unit main;

interface

uses
    Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls ,Dic32u;

type
    TForm1 = class(TForm)
    Button1: TButton;
    List: TListBox;
    procedure Button1Click(Sender: TObject);
    private
        { Private declarations }
    public
        { Public declarations }
    end;

var
    Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
hDic32: THandle;
str:string;
errcode:Integer;    // error code
num:Integer;	    // number of reader
hic:Integer;        // device handle
i:Integer;
cmddata:array[0..256] of Char;
wZone, wAgent, wUser1, wUser2:WORD ;

begin
    List.Items.Clear();
 
    num := DIC_Find();
    for i:=0 to num-1 do
    begin
	    hic := DIC_Open(i, nil);
		if hic >= 0 then break;		// Find the first ROCKEY
	end;
    if i = num then exit;

   	errcode := DIC_Command(hic, GET_MANAGER_CODE, cmddata);
	wZone := DIC_Get(cmddata, ZONE, BY_VALUE, nil);
	wAgent := DIC_Get(cmddata, AGENT, BY_VALUE, nil);
	wUser1 := DIC_Get(cmddata, USER1, BY_VALUE, nil);
	wUser2 := DIC_Get(cmddata, USER2, BY_VALUE, nil);
	FmtStr(str,'Zone code   %x', [wZone]);
    List.Items.Add(str);
	FmtStr(str,'Agent code  %x', [wAgent]);
    List.Items.Add(str);
	FmtStr(str,'User1  %x', [wUser1]);
    List.Items.Add(str);
	FmtStr(str,'User2   %x', [wUser2]);
    List.Items.Add(str);

    errcode := DIC_Close(hic);
 
end;

end.


