// ==========================================================================
// counter
// (1) set counter
// (2) start counter
// description
//  (1) if set the counter to 0, it means no limitation
//  (2) if the counter decreases to 0, the it stops and becomes invalid
// ==========================================================================
unit main;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls ,Dic32u;

type
  TForm1 = class(TForm)
  Label1: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure SampleEntry();
var
   i,j,num,hic,errcode,exesize, datasize, readsize:Integer;
   name:Array[0..50]of char;
   cmddata:Array[0..500]of char;
   buff,buffer,c_exefile,c_datafile:Array[0..511]of char;
   str,strTmp:string;
   dwMaxCounter: DWORD ;


begin

   num := DIC_Find();
   i:=0;
   while(i<num) do
	begin
		hic := DIC_Open(i, @name);
		if (hic >= 0) then break;		// Find the first ROCKEY
      i:=i+1;
	end;
	if (i = num) then exit;

   
  
   	//format
   	// a.verify supper password
	for i:=0 to 7 do  cmddata[i] := char($ff); // demo password is 8 'FF's
	errcode := DIC_Command(hic, CHECK_SUPER_PASS, cmddata);
   if(errcode<>0) then showMessage('CHECK_SUPER_PASS err');
   
   	//SET COUNTER
	dwMaxCounter := 10;
	errcode := DIC_Command(hic, SETCOUNTER, @dwMaxCounter);
	if(errcode<>0) then showMessage('SETCOUNTER err');

	DIC_Close(hic);


//////////////////////////////////////////////////////////////////////////
	hic := DIC_Open(hic,nil);

	// STEPCOUNTER
	for i := 1 to dwMaxCounter+1 do
	begin 
		errcode := DIC_Command(hic, STEPCOUNTER, nil);
		if (errcode <> SCARD_S_SUCCESS) then 
		begin 
			if (i>=dwMaxCounter) then 
			begin
            fmtstr(strtmp,'%d > Counter(%d),over counter limitation',[i,dwMaxCounter]);
				ShowMessage(strtmp);
				for j:=0 to 7 do  cmddata[j] := char($ff); // demo password is 8 'FF's
	         errcode := DIC_Command(hic, CHECK_SUPER_PASS, cmddata);
            if(errcode<>0) then showMessage('CHECK_SUPER_PASS err');

				//if set the counter to 0, it means no limitation
				dwMaxCounter := 0;
				errcode := DIC_Command(hic, SETCOUNTER, @dwMaxCounter);
				if (errcode <> SCARD_S_SUCCESS) then 
				begin 
					ShowMessage('Set counter error');
				end; 

			end 
			else 
         begin 
				ShowMessage('Setp counter error');
			end; 

		end; 
	end; 

 ///////////////////////////////////////////////////
	errcode := DIC_Close(hic);

end;


procedure TForm1.FormCreate(Sender: TObject);

begin
   SampleEntry();

end;

end.
