! ==========================================================
! find, open and close ROCKEY
! ==========================================================

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code
integer*4 num 				! number of ROCKEY
integer*4 hic 				! device handle
integer*4 i  
CHARACTER*256 reader_name

	write(*,*) 'Searching ROCKEY ' 
	num = DIC_Find() 
	write(*,*) num 
	if (num <= 0) then	
		write(*,*)'No ROCKEY found' 
		stop
	endif 

	write(*,*) 'Open ROCKEY' 
	do i=0, num-1 	
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then 
		    exit       		! Find the first ROCKEY
		endif
	enddo
	if (i == num) then
		write(*,*)'No ROCKEY found' 
		stop
	endif 

	! ...
	! operate ROCKEY
	! ...

	write(*,*)'Close ROCKEY'
	errcode = DIC_Close(hic) 
	if (errcode /= SCARD_S_SUCCESS) then
		write(*,'(" Error code: ",Z8)') errcode 
		stop
	endif 
end 

    
