! ==========================================================================
! ==========================================================================
! Get manufacture and main volume info
! (1) A card has two main info, the first is ATR, and the other is main volume
! (2) ATR is generated automatically when file is created. In general, manufact
!     will write its info into ATR. The max. length of ATR is 15 bytes, and such
!     info can be read by DIC_OPEN.
! (3) The main volume of a card is 16 bytes, and such volume works as a driver name
! (4) DIC_Get will read the ATR or VOLUME info into its buffer, and the return of 
!     Dic_Get is the length of buffer.
! (5) Run GET_CARD_INFO with DIC_Command before DIC_Get.
! ==========================================================================! ==========================================================================
! Get manufacture and main volume info
! (1) A card has two main info, the first is ATR, and the other is main volume
! (2) ATR is generated automatically when file is created. In general, manufact
!     will write its info into ATR. The max. length of ATR is 15 bytes, and such
!     info can be read by DIC_OPEN.
! (3) The main volume of a card is 16 bytes, and such volume works as a driver name
! (4) DIC_Get will read the ATR or VOLUME info into its buffer, and the return of 
!     Dic_Get is the length of buffer.
! (5) Run GET_CARD_INFO with DIC_Command before DIC_Get.
! ==========================================================================
! ==========================================================================

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code
integer*4 num 				! number of ROCKEY
integer*4 hic 				! device handle
integer*4 i
integer*4 j 
integer*4 ret_code
CHARACTER*256 reader_name
CHARACTER*256 cmddata 	! command buffer
CHARACTER  buffer(25)
CHARACTER*256 buffer1	! user buffer
  !	do i=0,25
		
!		buffer(i)='0'
		
		! find the first ROCKEY
!	enddo
	
	do i=1,256
	
	buffer1(i:256)=char(0)
    enddo


  !write(*,*) buffer1
	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		! find the first ROCKEY
	enddo

	if (i == num)  then
	stop
	endif

    
    !errcode = DIC_Command(hic, FORMAT_CARD, loc(cmddata)) 
	errcode = DIC_Command(hic, GET_CARD_INFO, loc(cmddata)) 
    
	
	
	!write(*,'(" main volume:   ",A31)') cmddata
	
	!ret_code=DIC_GetCardInfo(hic,loc(buffer),loc(buffer1))
	ret_code = DIC_Get( loc(cmddata), VOLUME, BY_ARRAY, loc(buffer1))  ! abstract main Volume from cmddata to buffer
	write(*,'(" main volume:   ",A16)') buffer1 
	
	
	ret_code = DIC_Get( loc(cmddata), ATR, BY_ARRAY, loc(buffer1)) 	! abstract ATR from cmddata to buffer
	
    do j=1,256
    
	
	if (buffer1(j:256)<=char(32) ) then 
    buffer1(j:256)=char(0) 
	endif
	
	if (buffer1(j:256)>=char(122)) then
	buffer1(j:256)=char(0) 
	
    endif

	enddo

   

	write(*,'(" manufacture info:",A15)') buffer1
	
	!write(*,'(A)') buffer1
	
	errcode = DIC_Close(hic) 

end

	