// ==========================================================================
// Demo: Write and run exe-file.
// Caution: no error check for the sake of briefness and understandability
// Tips:
// (1) You can write exe-files to dongle and run it in dongle. We have Integrate
//     Design Entironment(IDE), you can write,debug,and run program there.
// (2) dist.c is dongle program, we convert the compile result to bin file, and
//     put it to PC program via array.
// (3) You must write exe-file to root directory after super password verification.
// (4) Demo inclue 2 steps: write and run exe-file. The first step should finished befor
//     dongle vending. Then only second step is in final product.
// ==========================================================================
// dist.c caculate a^2+b^2
//
//void main()
//{
//	unsigned int a,b,c;
//	get_input(&a,0,1,1);
//	get_input(&b,2,1,1);
//	a=a*a;
//	b=b*b;
//	c=a+b;
//	set_response(2,&c);
//	exit();
//}

// ==========================================================================

import java.io.*;

public class Sample11
{
	public Sample11()
	{
	}

	public static void main(String [] args)
	{
		int i, num, hic=0, errcode;
		byte []cmddata=new byte[256];	//Note: should be larger then DIST_SIZE+4 
		byte []buffer=new byte[256];	//Note: should be large enough 
		short a, b, c;
		int DIST_SIZE = 193;
		byte temp;
		int g_progDIST[]=
		{
		0x02,0x00,0xb1,0x75,0x0e,0x00,0x75,0x0f,0x00,0x75,0x10,0x08,0xe4,0xf5,0x11,0x75,
		0x12,0x01,0x75,0x13,0x01,0x12,0x00,0x69,0x75,0x0e,0x00,0x75,0x0f,0x00,0x75,0x10,
		0x0a,0x75,0x11,0x02,0x75,0x12,0x01,0x75,0x13,0x01,0x12,0x00,0x69,0xae,0x08,0xaf,
		0x09,0xac,0x08,0xad,0x09,0x12,0x00,0x9f,0x8e,0x08,0x8f,0x09,0xae,0x0a,0xaf,0x0b,
		0xac,0x0a,0xad,0x0b,0x12,0x00,0x9f,0x8e,0x0a,0x8f,0x0b,0xe5,0x09,0x25,0x0b,0xf5,
		0x0d,0xe5,0x08,0x35,0x0a,0xf5,0x0c,0x75,0x0e,0x02,0x75,0x0f,0x00,0x75,0x10,0x00,
		0x75,0x11,0x0c,0x12,0x00,0x88,0x02,0x00,0xbd,0x12,0xff,0x00,0xe5,0x0e,0x24,0x00,
		0xe5,0x0f,0x24,0x01,0xe5,0x10,0x24,0x02,0xe5,0x11,0x24,0x03,0xe5,0x12,0x24,0x04,
		0xe5,0x13,0x24,0x05,0x12,0xff,0x0b,0x22,0x12,0xff,0x00,0xe5,0x0f,0x24,0x00,0xe5,
		0x10,0x24,0x01,0xe5,0x11,0x24,0x02,0xe5,0x0e,0x24,0x03,0x12,0xff,0x0a,0x22,0xef,
		0x8d,0xf0,0xa4,0xa8,0xf0,0xcf,0x8c,0xf0,0xa4,0x28,0xce,0x8d,0xf0,0xa4,0x2e,0xfe,
		0x22,0x78,0x7f,0xe4,0xf6,0xd8,0xfd,0x75,0x81,0x13,0x02,0x00,0x03,0x12,0xff,0x0d,
		0x22,
		};

		JavaRockey Rockey=new JavaRockey();
		num = Rockey.DIC_Find();
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, null);
			if (hic >= 0) break;		//find the first ROCKEY
		}
		if (i == num) return;
	
     		// a. Check supper password,it's required by writing process.
		for (i=0;i<8;i++) cmddata[i] = (byte)0xff; // Super password is 8 FFs for demo ROCKEY
		errcode = Rockey.DIC_Command(hic, Rockey.CHECK_SUPER_PASS, cmddata);
	
		// b. Create exe-file.
		Rockey.DIC_Set(cmddata, Rockey.FILL, 256, 0, null);						// clear buffer
		Rockey.DIC_Set(cmddata, Rockey.FILE_ID, Rockey.BY_VALUE, 0x0001, null);				// file ID
		Rockey.DIC_Set(cmddata, Rockey.FILE_CLASS, Rockey.BY_VALUE, 0xff, null);			// file class
		Rockey.DIC_Set(cmddata, Rockey.FILE_ATTRIBUTE, Rockey.BY_VALUE, Rockey.FILEATTR_EXEC, null);	// file attr
		Rockey.DIC_Set(cmddata, Rockey.FILE_SIZE, Rockey.BY_VALUE, DIST_SIZE, null);			// file size
		Rockey.DIC_Set(cmddata, Rockey.FILE_NAME, Rockey.BY_ARRAY, 0, "6002\0".getBytes());
		errcode = Rockey.DIC_Command(hic, Rockey.CREATE_FILE, cmddata);
	
		// c. Write exe-file
		for(i=0;i<DIST_SIZE;i++) buffer[i]=(byte)g_progDIST[i];
		Rockey.DIC_Set(cmddata, Rockey.WRITE_DATA, DIST_SIZE, 0, buffer);
		errcode = Rockey.DIC_Command(hic, Rockey.WRITE_FILE, cmddata);
	
		// d. return to password not verified status
		//    we cannot run program at super password verified status.
		errcode = Rockey.DIC_Close(hic);
		errcode = Rockey.DIC_Open(hic, null);
	
		// e. Run
		a = 3;
		b = 4;
		Rockey.DIC_Set(buffer, 0, 2, a, null);					// set a
		Rockey.DIC_Set(buffer, 2, 2, b, null); 					// set b
	
		Rockey.DIC_Set(cmddata, Rockey.RUN_DATA, 4, 0x6002, buffer);		// set data
		errcode = Rockey.DIC_Command(hic, Rockey.RUN, cmddata);
		Rockey.DIC_Get(cmddata, Rockey.RUN_DATA, Rockey.BY_VALUE, buffer);	// get data
		//change data order
		temp=buffer[0];
		buffer[0]=buffer[1];
		buffer[1]=temp;
		c = (short)Rockey.DIC_Get(buffer, 0, Rockey.BY_VALUE |2, null);		// Get c from buffer
	
		System.out.println(a+"*"+a+"+"+b+"*"+b+"="+c);
		errcode = Rockey.DIC_Close(hic);
	}

}