// ==========================================================================
// counter
// (1) set counter
// (2) start counter
// description
//  (1) if set the counter to 0, it means no limitation
//  (2) if the counter decreases to 0, the it stops and becomes invalid
// ==========================================================================

import java.io.*;

public class Sample16
{
	public Sample16()
	{
	}
	public static void main(String [] args)
	{
		int i,num, hic=0, errcode,index=0;
		byte []cmddata=new byte[256];
	
		JavaRockey Rockey=new JavaRockey();
		System.out.print("Searching ROCKEEY  ");
		num = Rockey.DIC_Find();
		if (num <= 0)
		{
			System.out.println("No ROCKEY found");
			return;
		}
		System.out.println(num);
	
		System.out.println("Open ROCKEY");
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, null);	
			index = i;
			if (hic >= 0) break;		// find the first ROCKEY
		}
		if (i == num)
		{
			System.out.println("No ROCKEY found");
			return;
		}
		
		for(i=0;i<8;i++) cmddata[i]=(byte)0xff;
		errcode = Rockey.DIC_Command(hic, Rockey.CHECK_SUPER_PASS, cmddata);
		if (errcode != Rockey.SCARD_S_SUCCESS) {
			System.out.println("Verify Super Pass error : "+Integer.toHexString(errcode&0xff));
		}
	
		//set counter
		int dwMaxCounter = 5;
		byte tmp[]={(byte)dwMaxCounter,(byte)0,(byte)0,(byte)0};
		errcode = Rockey.DIC_Command(hic, Rockey.SETCOUNTER, tmp);
		if(errcode != Rockey.SCARD_S_SUCCESS)
		{
			System.out.println("Set counter error :"+Integer.toHexString(errcode));		
		}
	
		Rockey.DIC_Close(hic);
		
		
	//////////////////////////////////////////////////////////////////////////
		hic = Rockey.DIC_Open(index,null);
	
		// STEPCOUNTER
		for(i=0; i<dwMaxCounter+1; i++)
		{
			errcode = Rockey.DIC_Command(hic, Rockey.STEPCOUNTER, cmddata);
			if(errcode != Rockey.SCARD_S_SUCCESS)
			{
				if(i>=dwMaxCounter)
				{
					System.out.println(" i> dwMaxCounter");
					for(i=0;i<8;i++) cmddata[i]=(byte)0xff;
					errcode = Rockey.DIC_Command(hic, Rockey.CHECK_SUPER_PASS, cmddata);
					if (errcode != Rockey.SCARD_S_SUCCESS) {
						System.out.println("Verify Super Pass error : "+Integer.toHexString(errcode));
					}
					
					//if set the counter to 0, it means no limitation
					dwMaxCounter = 0;
					tmp[0]=tmp[1]=tmp[2]=tmp[3]=(byte)0;
					errcode = Rockey.DIC_Command(hic, Rockey.SETCOUNTER, tmp);
					if(errcode != Rockey.SCARD_S_SUCCESS)
					{
						System.out.println("Set counter error :"+Integer.toHexString(errcode));		
					}
					
				}			
				else{
					System.out.println("step counter error : "+Integer.toHexString(errcode));			
				}
				
			}
		}
	
		Rockey.DIC_Close(hic);
	}
}