// ==========================================================
// find, open and close ROCKEY
// ==========================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"

void a(void *p)
{
    *((int *)p)=9;
}
void main()
{
	int errcode;				// error code
	int num;				// number of ROCKEY
	int hic;				// device handle
	int i;
	
	printf("int :%d\n",sizeof(int));
	printf("long :%d\n",sizeof(long));
	printf("LONG :%d\n",sizeof(LONG));
	printf("UINT :%d\n",sizeof(UINT));
	printf("WORD :%d\n",sizeof(WORD));
	printf("DWORD :%d\n",sizeof(DWORD));
	printf("int64 :%d\n",sizeof(__int64));
	printf("LONGLONG :%d\n",sizeof(LONGLONG));
	printf("int :%d\n",sizeof(int));
	printf("int :%d\n",sizeof(int));
	printf("searching ROCKEY: ");
	num = DIC_Find();
	printf("%d\n",num);
	if (num <= 0)
	{
		printf("No ROCKEY found\n");
		return;
	}

	printf("Open ROCKEY\n");
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);	
		if (hic >= 0) break;		// find the first ROCKEY
	}
	if (i == num)
	{
		printf("No ROCKEY found\n");
		return;
	}

	// ...
	// operate ROCKEY
	// ...

	printf("Close\n");
	errcode = DIC_Close(hic);
	if (errcode != SCARD_S_SUCCESS)
	{
		printf("error code: %08x\n", errcode);
		return;
	}
}
