// ==========================================================
// find, open and close all the ROCKEY
// ==========================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"

void main()
{
	int errcode;			// error code
	int num;				// number of ROCKEY
	int hic;				// device handle
	int i;
	char reader_name[256];	

	printf("searching ROCKEY");
	num = DIC_Find();
	printf("%d\n",num);
	if (num <= 0)
	{
		printf("No ROCKEY found\n");
		return;
	}

	for (i=0;i<num;i++)
	{

		printf("Open ROCKEY:");
		hic = DIC_Open(i, reader_name);
		if (hic < 0)
		{
			if (hic == SCARD_W_REMOVED_CARD)
			{
				printf("No ROCKEY found\n");
				continue;
			}
			printf("errcode: %08x\n", hic);
			return;
		}
		printf("%s\n", reader_name);

		// ...
		// operate ROCKEY
		// ...

		printf("close ROCKEY\n");
		errcode = DIC_Close(hic);
		if (errcode != SCARD_S_SUCCESS)
		{
			printf("errcode: %08x\n", errcode);
			return;
		}
	}
}
